Index: java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/resource/FramScriptResourceDescription.java
===================================================================
--- java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/resource/FramScriptResourceDescription.java	(revision 438)
+++ java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/resource/FramScriptResourceDescription.java	(revision 440)
@@ -13,4 +13,5 @@
 import com.framsticks.framclipse.framScript.State;
 import com.framsticks.framclipse.framScript.VariableDeclaration;
+import com.framsticks.framclipse.framScript.VariableDeclarations;
 import com.google.common.base.Predicate;
 import com.google.common.collect.Iterables;
@@ -19,7 +20,10 @@
 public class FramScriptResourceDescription extends DefaultResourceDescription {
 
+	private Resource resource;
+
 	public FramScriptResourceDescription(Resource resource,
 			IDefaultResourceDescriptionStrategy resourceDescriptionStrategy) {
 		super(resource, resourceDescriptionStrategy);
+		this.resource = resource;
 	}
 
@@ -49,5 +53,9 @@
 		if (input instanceof VariableDeclaration) {
 			VariableDeclaration dec = (VariableDeclaration) input;
-			return dec.eContainer().eContainer() instanceof Code;
+			EObject decs = dec.eContainer();
+			return decs instanceof VariableDeclarations &&
+					(decs.eContainer() instanceof Code ||
+							"inc".equals(resource.getURI().fileExtension()) &&
+							decs.eContainer().eContainer() == null);
 		}
 		return false;
Index: java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/scoping/FramScriptImportUriResolver.java
===================================================================
--- java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/scoping/FramScriptImportUriResolver.java	(revision 438)
+++ java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/scoping/FramScriptImportUriResolver.java	(revision 440)
@@ -8,12 +8,12 @@
 public class FramScriptImportUriResolver extends ImportUriResolver {
 	@Override
-	public String apply(EObject from) {
+	public String resolve(EObject from) {
 		if (from instanceof Header) {
 			Header header = (Header) from;
 			if (header.getName().equals("expdef:")) {
-				return header.getValue() + ".expdef";
+				return header.getImportURI() + ".expdef";
 			}
 		}
-		return super.apply(from);
+		return super.resolve(from);
 	}
 }
Index: java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/scoping/FramScriptScopeProvider.java
===================================================================
--- java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/scoping/FramScriptScopeProvider.java	(revision 438)
+++ java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/scoping/FramScriptScopeProvider.java	(revision 440)
@@ -20,7 +20,10 @@
 import org.eclipse.emf.ecore.EStructuralFeature;
 import org.eclipse.emf.ecore.resource.Resource;
+import org.eclipse.emf.ecore.resource.ResourceSet;
 import org.eclipse.emf.ecore.resource.impl.ResourceImpl;
 import org.eclipse.xtext.resource.EObjectDescription;
 import org.eclipse.xtext.resource.IEObjectDescription;
+import org.eclipse.xtext.resource.IResourceDescription;
+import org.eclipse.xtext.scoping.IGlobalScopeProvider;
 import org.eclipse.xtext.scoping.IScope;
 import org.eclipse.xtext.scoping.Scopes;
@@ -30,17 +33,25 @@
 import com.framsticks.framclipse.framScript.Block;
 import com.framsticks.framclipse.framScript.Code;
+import com.framsticks.framclipse.framScript.Expdef;
+import com.framsticks.framclipse.framScript.ForEachStatement;
+import com.framsticks.framclipse.framScript.ForStatement;
 import com.framsticks.framclipse.framScript.FramScriptFactory;
 import com.framsticks.framclipse.framScript.Function;
 import com.framsticks.framclipse.framScript.GotoStatment;
+import com.framsticks.framclipse.framScript.Header;
+import com.framsticks.framclipse.framScript.IncludeDeclaration;
 import com.framsticks.framclipse.framScript.Invocation;
 import com.framsticks.framclipse.framScript.LabeledStatement;
 import com.framsticks.framclipse.framScript.Model;
+import com.framsticks.framclipse.framScript.PropertyIncludeDeclaration;
 import com.framsticks.framclipse.framScript.ProposableFunctionImpl;
 import com.framsticks.framclipse.framScript.ProposableVariableDeclarationImpl;
 import com.framsticks.framclipse.framScript.QualifiedExpression;
+import com.framsticks.framclipse.framScript.Show;
 import com.framsticks.framclipse.framScript.Statement;
 import com.framsticks.framclipse.framScript.VariableDeclaration;
 import com.framsticks.framclipse.framScript.VariableDeclarations;
 import com.framsticks.framclipse.framScript.VariableRef;
+import com.framsticks.framclipse.resource.FramScriptResourceDescriptionManager;
 import com.framsticks.framclipse.script.ConstantProvider;
 import com.framsticks.framclipse.script.ExpressionTraverser;
@@ -54,20 +65,27 @@
  * This class contains custom scoping description.
  * 
- * see : http://www.eclipse.org/Xtext/documentation/latest/xtext.html#scoping
- * on how and when to use it 
- *
+ * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#scoping
+ * on how and when to use it.
  */
 public class FramScriptScopeProvider extends AbstractDeclarativeScopeProvider {
-	
+
 	private final ConstantProvider provider;
-	
+
 	private final ExpressionTraverser traverser;
-	
+
+	@Inject
+	private IGlobalScopeProvider globalScopeProvider;
+
+	@Inject
+	private FramScriptResourceDescriptionManager descriptionManager;
+
 	private Resource resource;
-	
+
 	private Map<String, IScope> typesScopes = Maps.newHashMap();
 	private Map<Type, IScope> functionScopes = Maps.newHashMap();
 	private Map<Type, IScope> fieldScopes = Maps.newHashMap();
-	
+
+	private FramScriptImportUriResolver resolver = new FramScriptImportUriResolver();
+
 	@Inject
 	public FramScriptScopeProvider(ConstantProvider provider, ExpressionTraverser traverser) {
@@ -77,5 +95,72 @@
 		initTypes();
 	}
-	
+
+	@Override
+	public IScope getScope(EObject context, EReference reference) {
+		if (reference.getEContainingClass().getName().equals("VariableRef") &&
+				reference.getName().equals("var")) {
+			if (context instanceof VariableRef) {
+				QualifiedExpression parent = getParent((VariableRef) context);
+				if (parent != null) {
+					return getScope(parent, reference);
+				}
+				EObject object = context;
+				while (object != null && !(object.eContainer() instanceof Block ||
+						object.eContainer() instanceof ForStatement ||
+						object.eContainer() instanceof ForEachStatement)) {
+					object = object.eContainer();
+				}
+				Statement statement = (Statement) object;
+				EObject blockOrFor = object.eContainer();
+
+				if (blockOrFor instanceof Block) {
+					Block block = (Block) blockOrFor;
+					return Scopes.scopeFor(precedingDeclarations(block, statement),
+							nextValidScope(block, reference));
+				} else
+					return getScope(blockOrFor, reference);
+			} else if (context.eContainer() instanceof Block) {
+				Block block = (Block) context.eContainer();
+				List<VariableDeclaration> vars = precedingDeclarations(block, (Statement)context);
+				IScope outerScope = Scopes.scopeFor(vars, nextValidScope(block, reference));
+				if (context instanceof Block) {
+					return outerScope;
+				}
+				return new SimpleScope(outerScope,
+						super.getScope(context, reference).getAllElements());
+			}
+		}
+		return super.getScope(context, reference);
+	}
+
+	private IScope nextValidScope(EObject context, EReference ref) {
+		if (ref.getEContainingClass().getName().equals("VariableRef") &&
+				ref.getName().equals("var")) {
+			if (context instanceof Block) {
+				EObject parent = context.eContainer();
+				if (parent == null) {	// may happen in .inc files.
+					return scope_VariableRef_var((Model)context, ref);
+				}
+				if (!(parent instanceof Block)) {
+					return getScope(parent, ref);
+				}
+			}
+		}
+		return getScope(context, ref);
+	}
+
+	private List<VariableDeclaration> precedingDeclarations(Block block, Statement statement){
+		List<VariableDeclaration> vars = Lists.newArrayList();
+		for (Statement stmt : block.getStatements()) {
+			// Everything after the statement is out of scope.
+			if (stmt == statement) {
+				break;
+			} else if (stmt instanceof VariableDeclarations) {
+				vars.addAll(((VariableDeclarations) stmt).getVars());
+			}
+		}
+		return vars;
+	}
+
 	protected void initTypes() {
 		List<Function> allFunctions = Lists.newArrayList();
@@ -116,6 +201,8 @@
 			scope = scope_Invocation_function(getFunction(inv), ref);
 		}
-		scope = filterByArgumentsCount(scope, inv.getArgs().size());
-		return scope;
+		Show show = getShow(inv);
+		IScope showScope = show == null ? IScope.NULLSCOPE :
+			new SimpleScope(filterByArgumentsCount(getScope(show, ref), inv.getArgs().size()));
+		return new SimpleScope(showScope, filterByArgumentsCount(scope, inv.getArgs().size()));
 	}
 
@@ -132,5 +219,12 @@
 	}
 
-	private IScope filterByArgumentsCount(IScope scope, int size) {
+	protected IScope scope_Invocation_function(Show show, EReference ref) {
+		return addAliases(new SimpleScope(showExpdefIncludes(show, ref)));
+	}
+
+	/*
+	 * Make sure scope contains only function descriptions.
+	 */
+	private List<IEObjectDescription> filterByArgumentsCount(IScope scope, int size) {
 		List<IEObjectDescription> filtered = Lists.newArrayList();
 		for (IEObjectDescription desc : scope.getAllElements()) {
@@ -140,7 +234,7 @@
 			}
 		}
-		return new SimpleScope(filtered);
-	}
-	
+		return filtered;
+	}
+
 	private IScope addAliases(IScope scope) {
 		Iterable<IEObjectDescription> contents = scope.getAllElements();
@@ -155,29 +249,50 @@
 	}
 
-	protected IScope scope_VariableRef_var(VariableRef var, EReference ref) {
-		QualifiedExpression parent = getParent(var);
-		if (parent != null) {
-			return scope_VariableRef_var(parent, ref);
-		} else {
-			return scope_VariableRef_var(getBlock(var), ref);
-		}
-	}
-
 	protected IScope scope_VariableRef_var(QualifiedExpression var, EReference ref) {
 		Type type = traverser.getLastType(var);
 		IScope scope = fieldScopes.get(type);
-		return scope != null ? scope : IScope.NULLSCOPE;
-	}
-	
+		return new SimpleScope(nextValidScope(var.eContainer(), ref),
+				scope != null ? scope.getAllElements() : new ArrayList<IEObjectDescription>());
+	}
+
 	protected IScope scope_VariableRef_var(Block block, EReference ref) {
+		// Scope for Blocks is constructed earlier in getScope, so we stop here.
+		return IScope.NULLSCOPE;
+	}
+
+	protected IScope scope_VariableRef_var(ForStatement fs, EReference ref) {
 		List<VariableDeclaration> vars = Lists.newArrayList();
-		for (Statement stmt : block.getStatements()) {
-			if (stmt instanceof VariableDeclarations) {
-				vars.addAll(((VariableDeclarations) stmt).getVars());
-			}
-		}
-		return Scopes.scopeFor(vars, getScope(block.eContainer(), ref));
-	}
-	
+		Statement init = fs.getInit();
+		if (init instanceof VariableDeclarations) {
+			vars.addAll(((VariableDeclarations)init).getVars());
+		}
+		return Scopes.scopeFor(vars, getScope(fs.eContainer(), ref));
+	}
+
+	protected IScope scope_VariableRef_var(ForEachStatement fes, EReference ref) {
+		List<VariableDeclaration> vars = Lists.newArrayList();
+		if (fes.getDecl() == null)
+			return getScope(fes.eContainer(), ref);
+		else {
+			vars.add(fes.getDecl());
+			return Scopes.scopeFor(vars, getScope(fes.eContainer(), ref));
+		}
+	}
+
+	/*
+	 * Blocks are handled specially in getScope,
+	 * and scope_VariableRef_var(Block, EReference) returns IScope.NULLSCOPE,
+	 * which breaks the chain of scopes,
+	 * so we have to ensure each unspecified scope_VariableRef_var call
+	 * is redirected to getScope in this class, instead of super.getScope.
+	 */
+	protected IScope scope_VariableRef_var(EObject ctx, EReference ref) {
+		EObject parent = ctx.eContainer();
+		if (parent == null)
+			return IScope.NULLSCOPE;
+		else
+			return getScope(parent, ref);
+	}
+
 	protected IScope scope_VariableRef_var(Function f, EReference ref) {
 		List<VariableDeclaration> vars = Lists.newArrayList();
@@ -185,5 +300,5 @@
 		return Scopes.scopeFor(vars, getScope(f.eContainer(), ref));
 	}
-	
+
 	protected IScope scope_VariableRef_var(Code code, EReference ref) {
 		List<VariableDeclaration> vars = Lists.newArrayList();
@@ -193,9 +308,69 @@
 		return Scopes.scopeFor(vars, getScope(code.eContainer(), ref));
 	}
-	
+
+	private List<IEObjectDescription> showExpdefIncludes(Show show, EReference ref) {
+		ArrayList<IEObjectDescription> result = Lists.newArrayList();
+		// Get expdef header
+		Header expdefHeader= null;
+		for (Header h : show.getHeaders()) {
+			if ("expdef:".equals(h.getName())) {
+					expdefHeader = h;
+					break;
+			}
+		}
+		if (expdefHeader == null)
+			return result;
+		// Find resource by name
+		ResourceSet resourceSet = show.eResource().getResourceSet();
+		String expdefFile = resolver.resolve(expdefHeader);
+		Resource expdefResource = findResourceByName(resourceSet, expdefFile);
+		if (expdefResource == null)
+			return result;
+		// Mine include directives
+		ArrayList<String> included = Lists.newArrayList();
+		Expdef expdef = (Expdef) expdefResource.getContents().get(0);
+		for (PropertyIncludeDeclaration pid : expdef.getPropertyImports())
+			included.add(pid.getImportURI());
+		for (IncludeDeclaration id : expdef.getCode().getIncludes())
+			included.add(id.getImportURI());
+		// Get globals
+		for (String filename : included) {
+			Resource includedResource = findResourceByName(resourceSet, filename);
+			if (includedResource == null) {
+				String showURI = show.eResource().getURI().toString();
+				URI includeURI = URI.createURI(showURI.subSequence(
+						0, showURI.lastIndexOf("/")+1) + filename);
+				includedResource = resourceSet.getResource(
+						includeURI, true);
+				if (includedResource == null)
+					continue;
+			}
+			IResourceDescription resourceDescription =
+					descriptionManager.getResourceDescription(includedResource);
+			result.addAll(Lists.newArrayList(resourceDescription.getExportedObjectsByType(ref.getEReferenceType())));
+		}
+		return result;
+	}
+
+	private Resource findResourceByName(ResourceSet resourceSet,
+			String filename) {
+		for (Resource res : resourceSet.getResources()) {
+			if (res.getURI().toString().endsWith("/" + filename)) {
+				return res;
+			}
+		}
+		return null;
+	}
+
 	protected IScope scope_VariableRef_var(Model model, EReference ref) {
-//		IScope outerScope = delegateGetScope(model, ref).getOuterScope();
-		IScope types = typesScopes.get(getExtension(model));
-		return new SimpleScope(types.getAllElements());
+		IScope outerScope = globalScopeProvider.getScope(model.eResource(), ref, null);
+		if (model instanceof Show) {
+			outerScope = new SimpleScope(outerScope, showExpdefIncludes((Show)model, ref));
+		}
+		String ext = getExtension(model);
+		if ("inc".equals(ext))	// There is no description for .inc in XML,
+			ext = "script";	// so we pretend it is a .script.
+		IScope types = typesScopes.get(ext);
+		return new SimpleScope(outerScope, types.getAllElements());
 	}
 
@@ -211,5 +386,13 @@
 		return Scopes.scopeFor(labels);
 	}
-	
+
+	protected IScope scope_Property(Show show, EReference ref) {
+		return new SimpleScope(delegateGetScope(show, ref), showExpdefIncludes(show, ref));
+	}
+
+	protected IScope scope_State(Show show, EReference ref) {
+		return new SimpleScope(delegateGetScope(show, ref), showExpdefIncludes(show, ref));
+	}
+
 	private Function createFunction(Element element) {
 		Function function = new ProposableFunctionImpl(element);
@@ -233,5 +416,5 @@
 		return global;
 	}
-	
+
 	private VariableDeclaration createVariableDeclaration(String name) {
 		VariableDeclaration var = FramScriptFactory.eINSTANCE.createVariableDeclaration();
@@ -240,10 +423,10 @@
 		return var;
 	}
-	
+
 	private QualifiedExpression getParent(QualifiedExpression expr) {
 		EStructuralFeature feature = expr.eContainingFeature();
 		if (feature.equals(QUALIFIED_EXPRESSION__CHILD)) {
 			return (QualifiedExpression) expr.eContainer();
-		} else if (feature.equals(QUALIFIED_EXPRESSION__PARENT) 
+		} else if (feature.equals(QUALIFIED_EXPRESSION__PARENT)
 				|| feature.equals(ARRAY_ELEMENT_EXPRESSION__ARRAY)) {
 			return getParent((QualifiedExpression) expr.eContainer());
@@ -252,12 +435,5 @@
 		}
 	}
-	
-	private Block getBlock(EObject object) {
-		while (object != null && !(object instanceof Block)) {
-			object = object.eContainer();
-		}
-		return (Block) object;
-	}
-	
+
 	private Function getFunction(EObject object) {
 		while (object != null && !(object instanceof Function)) {
@@ -266,8 +442,15 @@
 		return (Function) object;
 	}
-	
+
+	private Show getShow(EObject object) {
+		while (object != null && !(object instanceof Show)) {
+			object = object.eContainer();
+		}
+		return (Show) object;
+	}
+
 	private String getExtension(EObject object) {
 		return object.eResource().getURI().fileExtension();
 	}
-	
+
 }
Index: java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/script/XMLConstantProvider.java
===================================================================
--- java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/script/XMLConstantProvider.java	(revision 438)
+++ java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/script/XMLConstantProvider.java	(revision 440)
@@ -85,5 +85,5 @@
 		for (File file : framscontext.getFiles()) {
 			String ext = file.getPattern();
-			ext = ext.substring(ext.indexOf('.') + 1, ext.length());
+			ext = ext.substring(ext.lastIndexOf('.') + 1, ext.length());
 			if (file.getCode() != null) {
 				for (Context context : file.getCode().getContexts()) {
Index: java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/script/model/Element.java
===================================================================
--- java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/script/model/Element.java	(revision 438)
+++ java/Framclipse/com.framsticks.framclipse/src/com/framsticks/framclipse/script/model/Element.java	(revision 440)
@@ -21,5 +21,5 @@
 	@XStreamAlias("default")
 	@XStreamAsAttribute
-	private Double def;
+	private String def;
 
 	private String description;
@@ -47,5 +47,5 @@
 	}
 
-	public Double getDef() {
+	public String getDef() {
 		return def;
 	}
